# Описание
DITranquallity - это небольшая библиотека для внедрения зависимостей для iOS приложений написанных на Swift. Библиотека поддерживает "Чистые" Swift типы.

# Особенности
* Поддержка "чистых" Swift типов
* Нативность
* Статическая типизация
* Внедрения зависимостей через: метод инициализации, свойства, обычный метод
* Следит за временем жизни объектов
* Поддержка Storyboard
* Возможность указывать несколько типов по которым доступен объект
* Регистрация/Получение объекта по типы и имени (или именам)
* Инициализация с параметрами
* Несколько уровней регистрации: тип, модуль, сборка
* Множественная регистрация - получение нескольких разных объектов по одному типы
* Поддержка циклических зависимостей
* Специальный "краткий" синтаксис для разрешения зависимостей

# Главы

## [Быстрый старт](quick_start.md)
* Структура приложений
* Добавление DITranquallity в ваш проект
* Регистрация зависимостей
* Разрешение зависимостей
* Что дальше?

## [Базовая регистрации зависимостей](registration.md)
* Регистрация зависимости
* Метод инициализации
* Указание альтернативных типов
* Разрешение зависимостей при инициализации
* Методы для добавления зависимостей
* Циклические ссылки
* Передача параметров

## [Создание контейнера](build.md)
* Зачем?
* Процесс создания
* Проверки во время создания
* Чего нету

## [Время жизни](timelife.md)
* Зачем?
* Стандартное (Default)
* Одиночки (Single)
* Отложенные одиночки (LazySingle)
* Область видимости (Scope)
* Всегда новый (Dependency)
* За создание отвечает кто-то другой (Request)

## [Регистрация с указанием имени/множественная регистрация](multi_name_registration.md)
* Множественная регистрация
* Указание Стандартной (Default) зависимости
* Регистрация с указанием имени

## [Разрешение зависимостей](resolve.md)
* Разрешение по типу
* Разрешение по типу и имени
* Разрешение зависимостей для множественной регистрации
* Разрешение зависимостей с параметрами
* Автоматический вывод типов
* Проверки во время разрешения зависимостей
* Сокращенный синтаксис

## [Модули](module.md)
* Что такое модуль?
* Создание модуля
* Регистрация модуля

## [Сборки](assembly.md)
* Зачем?
* Создание
* Публичный/обычный модуль
* Как использовать
* Динамические сборки
* Нюансы

## [Storyboard](storyboard.md)
* Объявление зависимостей для ViewController
* Создание Storyboard

## [Примеры](sample.md)
* Chaos
* Delegate and Observer
* Big Project

# "Идеальная" архитектура приложения

# Планы
* Поддержка WatchOS
* Поддержка MacOS
* Поддержка swift 3


